;SNT.LSP - copy text aligned to line/pline, centered on line/segment picked
;          layer/color same as original text
;          user may also erase original, flip copy 180 and edit copy...
;
;from: Western Sierra Software Works!
; for: Sacramento AutoCAD Users Group
;  by: Robert Creamer  November 1992 
;      (Original routine date, erase, 180 & edit added 8-93 to 3-94...rbc)
;      (added real error checking 3-95 rbc) 
;This routine modified using Visual LISP, WSSW's Win 3.1 AutoLISP Editor.
;
;load/run macro in Acad.lsp is (defun c:snt () (load "snt")(c:snt))
;load/run macro in Acad.mnu is [snap text to line]^c^c(if (not c:snt)(load "snt"));snt;
;
;
(defun WSSW_ERR (ick) 					;semi-standard error
 (if (/= ick "Function cancelled") 			;if you didn't cancel
  (princ (strcat "\nThe error was: " ick)) 		;we tell you what did
  (princ "/nGo ahead, cancel my function..."))		;we tell you you did
 (if OLERR (setq *ERROR* OLERR)(setq *ERROR* nil))	;reset error function
(princ)							;no nil
)							;end wssw_err
;
(defun N_L2 () (prompt "\n ")(prompt "\n ")(princ))	;2 blank linefeeds
;
(DEFUN C:SNT ()						;start defun
 (setq OLERR *ERROR* *ERROR* WSSW_ERR)			;set error to wssw_err
 (if (not !ALERT) 					;1st time thru show
  (progn (alert "\nPick line/pline, then text")(setq !alert T)));program needs
 (N_L2)							;linefeed 
 (setq SNL (entsel "\nPick line/pline for alignment: "));pic as instructed
 (if SNL 						;if pic entity, if 1
  (progn						;progn 1
   (setq SNLE (cdr (assoc 0 (entget (car SNL)))))	;check entity type
   (if (or (= SNLE "LINE")(= SNLE "POLYLINE"))		;if line/pline, if 2
    (progn (N_L2)					;progn 2 & linefeed
     (setq SNTX (entsel "\nSelect text to copy & align: ")) ;ask for text
     (if (= "TEXT" (cdr (assoc 0 (entget (car SNTX)))))	;check ent type & if 3
      (progn						;progn 3, run that baby
       (if (/= 0 (setq O_CMD (getvar "cmdecho")))(setvar "cmdecho" 0));no echo	
       (setq 	EPT1 (osnap (setq 				;snap points on
		NPT1 (osnap (cadr SNL) "NEAREST")) "ENDPOINT")	;line/pline
       		MPT1 (osnap NPT1 "MIDPOINT") 			;end, mid, near
       		ANL (angle NPT1 EPT1)    DL (distance MPT1 EPT1);text attribs
        	AT2 (entget (car SNTX))  TX1 (cdr (assoc 1 AT2));look up in
	 	HT (cdr (assoc 40 AT2))  ST (cdr (assoc 7 AT2)) ;DXF group code
	 	TXL (cdr (assoc 8 AT2))  TXC (cdr (assoc 62 AT2)) );summary
       (if (or (= 0 TXC)(= nil TXC)) (setq TXC "bylayer") )	;check color 
       (if(and(< 1.57 ANL)(> 4.71 ANL))(setq ANL (+ 3.14 ANL)))	;check angle
       (if(= 1.5708 ANL)(setq ANL 1.5708))(setq ANT (/ (* ANL 180.0) pi));etc
       (command "text" "s" ST "j" "bc" MPT1 HT ANT TX1 		;run copy
	        "chprop" "L" "" "LAYER" TXL "COLOR" TXC "")(N_L2);& properties
       (initget "Y N")						;setup for
       (setq Y_N (getkword "\nerase original text? <N> : "))(N_L2);erase original
       (if (= Y_N "Y") (command "erase" SNTX "")) 		;& do it
       (initget "Y N")						;setup for
       (setq Y_N2 (getkword "\nRotate 180? <N> : "))(N_L2)	;rotate copy 
       (if (= Y_N2 "Y")(command "rotate" "L" "" MPT1 180.0)) 	;& do it
       (initget "Y N")						;setup for
       (setq Y_N3 (getkword "\nEdit new text? <Y> : "))		;edit copy
       (if (or (= Y_N3 "Y")(= Y_N3 nil))(command "_ddedit" (entlast) ""));do it
       (if (/= 0 O_CMD)(setvar "cmdecho" 1))			;reset cmdecho
       (if (not SNT_OK) (setq SNT_OK T )(setq SNT_OK ZZZ))	;setup for thanks
      )								;end progn 3
      (alert "\nPick text after line/pline")			;oops not text
     )								;end if 3
    )								;end progn 2
    (alert "\nPick line/pline only first")			;oops not line
   ) 								;end if 2
  )								;end progn 1
  (alert "\n You have to pick to play \n Return to try again...");oops no pic
 )								;end if 1
 (N_L2)								;linefeed
 (if (= SNT_OK T)						;thank you msg
   (prompt "\nSNT.lsp\nFreeware from Western Sierra Software Works!");from WSSW
 )								;once only
 (if OLERR (setq *ERROR* OLERR)(setq *ERROR* nil))		;reset error
 (princ)							;no nil
)								;end SNT defun					
;added newline function for clarity, my users seem to like seeing only one
;instruction or message at a time.  Nested if's not the only way to handle 
;input, but easy to check each step as it's being made & nuke process at 
;each step of the way with instruction on how to do it right next time...
;speaking of which, see you next time, RBC